;drawlib
;EXTRN sym_plot:proc
plot MACRO
        .IF ecx<1280
            .IF ecx>0
                .IF edx<1024
                    .IF edx>0
        mov ebx,edx
        sal ebx,6
        mov [plotadot],ebx
        sal ebx,2
        add ebx,[plotadot]
        sal ebx,2 ;1280
        add ebx,ecx
        sal ebx,2 ;2
        add ebx,[ddsd.lpSurface]
        
        mov [ebx],eax
            .ENDIF
            .ENDIF
            .ENDIF
            .ENDIF
        ENDM
        plot2 MACRO
        .IF ecx<1280
            .IF ecx>0
                .IF edx<1024
                    .IF edx>0
        mov ebx,edx
        sal ebx,6
        mov [plotadot],ebx
        sal ebx,2
        add ebx,[plotadot]
        sal ebx,2 ;1280
        add ebx,ecx
        sal ebx,2
        add ebx,[ddsd.lpSurface]
        add eax,[ebx]
        mov [ebx],eax
            .ENDIF
            .ENDIF
            .ENDIF
            .ENDIF
        ENDM

plotb MACRO
        .IF ecx<1280
            .IF ecx>0
                .IF edx<1024
                    .IF edx>0
        mov ebx,edx
        sal ebx,6
        mov [plotadot],ebx
        sal ebx,2
        add ebx,[plotadot]
        sal ebx,2 ;1280
        add ebx,ecx
        sal ebx,2
        add ebx,[ddsd.lpSurface]
        ;add ebx,2
        mov [ebx],al
            .ENDIF
            .ENDIF
            .ENDIF
            .ENDIF
        ENDM


plot3   MACRO
        pushad
        push ebx
        mov eax,edx
        ;sub eax,512
        xor edx,edx
        idiv ebx
        ;add eax,512
        mov Y1,eax
        mov eax,ecx
        ;sub eax,640
        xor edx,edx
        pop ebx
        idiv ebx
        ;add eax,640
        mov X1,eax
        popad
        mov ecx,X1
        mov edx,Y1
        plot
        ENDM
        
        
        
        

.DATA

X1              dd 0    ; Coordinates of the line
Y1              dd 0    ; contained in the calling
X2              dd 0    ; pgm's parameter block
Y2              dd 0    
colour          db 0    
plotadot        dd 0    ; Address of dot plotting routine
;-------------------------------; End of parameter block
.DATA?
ddsd			DDSURFACEDESC		<?>		; DDraw surface descriptor

decision        dd   ?       ; The decision variable
delta_x         dd      ?
delta_y         EQU     delta_x
incr1           dd      ?       ; Increment 1
incr2           dd      ?       ; Increment 2
xend            dd   ?       ; Line end point
yend            EQU     xend
xinc            dd      ?       ; X increment
yinc            EQU     xinc
ebpsave         dd      ?

.CODE
        
 
        PUBLIC  line
;-------------------------------------------------------;
; Draws a straight line using Bresenham's algorithm     ;
;               Valid for all slopes.                   ;
;                                                       ;
; Entry:        si points at parameter block            ;
;-------------------------------------------------------;
line2   proc
        mov al,[colour]
        fild Y1
        fisub Y2
        fild X1
        fisub X2
        fdiv st(1),st(0)
        fild Y1
        mov edi,X1
        sub edi,X2
lline2: mov ecx,X1
        mov edx,Y1
        plot
        fadd st(0),st(1)
        fist Y1
        inc X1
        dec edi
        jne lline2
        ffree st(1)
        ffree st(0)
          
        

        ret
line2 endp
line    proc    ;USES ax bx cx dx di bp
        mov ebpsave,ebp
        mov     al,[colour]       ; Get the colour attribute

        mov     ebx,X1
        sub     ebx,X2           ; Get absolute difference
        jns     short   got_dx  ; for X2 - X1
        neg     ebx
got_dx: mov     delta_x,ebx      ; Save delta_x

        mov     ecx,Y1
        sub     ecx,Y2           ; Get absolute difference
        jns     short   got_dy  ; for Y2 - Y1
        neg     ecx
got_dy: mov     delta_y,ecx      ; Save delta_Y

        cmp     ecx,ebx           ; Test the slope.
                                ; Is delta_Y greater
        jae     slope_more_1    ; than delta_X
                                ; i.e the slope is GE 1

; This section handles lines with slopes less than 1

        shl     ecx,1            ; 2 * delta_Y
        mov     incr1,ecx        ; increment1 for case d < 0

        sub     ecx,ebx           ; 2 * delta_Y - delta_X
        mov     decision,ecx     ; initial decision variable

        sub     ecx,ebx           ; 2 * (delta_Y - delta_X)
        mov     incr2,ecx        ; increment2 for case d >= 0

        mov     edi,X1           ; Take copy of 1st points coords
        mov     ebp,X2

.IF     edi  >  ebp              ; If X1 larger X2

        mov     ebx,Y1
        mov     ecx,X2
        mov     edx,Y2
        mov     xend,edi         ; Set end of line, xend = X1

        .IF     delta_y == 0
                mov     yinc,0
        .ELSE
                .IF     edx > ebx         ; Is Y2 larger Y1 ?

                        mov     yinc,-1
                .ELSE
                        mov     yinc,1
                .ENDIF
        .ENDIF
.ELSE
        mov     ebx,Y2
        mov     ecx,X1
        mov     edx,Y1
        mov     xend,ebp         ; Set xend = X2

        .IF     delta_y == 0
                mov     yinc,0
        .ELSE
                .IF     ebx > edx         ; Is Y2 larger Y1 ?

                        mov     yinc,1
                .ELSE
                        mov     yinc,-1
                .ENDIF
        .ENDIF
.ENDIF
        ; The plotting routine is entered with coordinates
        ; X & Y in cx & dx; & colour attribute in al. Note
        ; that the bx register is altered by the routine.
        push ebx
        
        plot        ; Plot the first point
        pop ebx
        mov     ebp,incr1        ; Set regs with the 2 increments
        mov     edi,incr2

.WHILE  ecx <xend               ; While X less xend

        inc     ecx              ; Increment X
        .IF     decision < 0

                add     decision,ebp  ; Choose Si,no change in Y

        .ELSE                   ; else choose Ti, Y incremented

                add     edx,yinc         ; Increment Y
                add     decision,edi
        .ENDIF
        push ebx
        plot        ; Plot all other points
        pop ebx
.ENDW
        mov ebp,ebpsave
        ret                     ; Return to DOS

;       Here we handle lines with slopes GE 1

slope_more_1:

        shl     ebx,1            ; 2 * delta_X
        mov     incr1,ebx        ; increment1 for case d < 0

        sub     ebx,ecx           ; 2 * delta_X - delta_Y
        mov     decision,ebx     ; initial decision variable

        sub     ebx,ecx           ; 2 * (delta_X - delta_Y)
        mov     incr2,ebx        ; increment2 for case d GE 0

        mov     edi,Y1
        mov     ebp,Y2

.IF     edi  > ebp                 ; If Y1 larger Y2

        mov     ebx,X1
        mov     ecx,X2
        mov     edx,Y2
        mov     yend,edi         ; Set end of line, yend = Y1

        .IF     delta_x == 0
                mov     xinc,0
        .ELSE
                .IF     ecx >ebx         ; Is X2 greater X1 ?
                        mov     xinc,-1
                .ELSE
                        mov     xinc,1
                .ENDIF
        .ENDIF

.ELSE
        mov     ebx,X2
        mov     ecx,X1
        mov     edx,Y1
        mov     yend,ebp                 ; yend = Y2

        .IF     delta_x == 0
                mov     xinc,0
        .ELSE
                .IF     ebx > ecx         ; Is X2 larger X1 ?
                        mov     xinc,1
                .ELSE
                        mov     xinc,-1
                .ENDIF
        .ENDIF

.ENDIF
        plot        ; Plot the first point (cx,dx)

        mov     ebp,incr1        ; Set regs with the 2 increments
        mov     edi,incr2

.WHILE  edx  < yend            ; While Y less Yend

        inc     edx              ; Increment Y
        .IF     decision >0

                add     decision,ebp ; Choose Si, no change in X

        .ELSE                   ; else choose Ti, X incremented

                add     ecx,xinc ; Increment X
                add     decision,edi
        .ENDIF

        plot        ; Plot all other points (Xn,Yn)

.ENDW
        mov ebp,ebpsave
        ret                     ; Return to DOS
line    endp
        

.DATA
zero    dd  0       ;We compare a signed decision variable
YC      dd    0  ;Y of (X,Y) specifying the circle centre
radius  dd     0

.CODE
        PUBLIC  circle
;-----------------------------------------------;
; Draw a circle using the Michener/Bresenham    ;
; algorithm.                                    ;
; Entry         SI Points at parameter block    ;
;               containing the circle data      ;
;-----------------------------------------------;
circle  PROC    ;USES ax bx cx dx di

        xor     ecx,ecx           ; Initialise X to 0
        mov     edx,radius       ; Initialise Y

        mov     ebx,3            ; Initialise the decision variable
        sub     ebx,edx           ; in bx to
        sub     ebx,edx           ; 3 - (2 * radius)

.WHILE          ecx < edx         ; While X is less than Y
        push ebx
        push eax
        mov al,colour
        plot
        pop eax
        pop ebx
        ;call    sym_plot        ; Plot 8 symmetric points of circle

        .IF     ebx < zero       ; If decision variable is less than 0
                mov     eax,ecx   ; don't decrement Y
                shl     eax,2    ; 4 * X
                add     eax,6    ; (4 * X) + 6
        .ELSE
                mov     eax,ecx
                sub     eax,edx   ; X - Y
                shl     eax,2    ; 4 * (X - Y)
                add     eax,10   ; 4*(X - Y) + 10
                dec     edx      ; Decrement Y
        .ENDIF
                inc     ecx      ; Increment X
                add     ebx,eax   ; Update the decision variable
.ENDW

.IF             ecx == edx
        push ebx
        push eax
        mov al,colour
        plot
        pop eax
        pop ebx
        ;call    sym_plot        ; Draw a point in the 4 quarters

.ENDIF
        ret
circle  ENDP
        
